diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/lr-wpan/model/lr-wpan-mac.cc ns-3.46/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.45/src/lr-wpan/model/lr-wpan-mac.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/lr-wpan/model/lr-wpan-mac.cc	2025-10-01 18:46:32.000000000 -0700
@@ -15,7 +15,6 @@
 
 #include "lr-wpan-constants.h"
 #include "lr-wpan-csmaca.h"
-#include "lr-wpan-mac-header.h"
 #include "lr-wpan-mac-pl-headers.h"
 #include "lr-wpan-mac-trailer.h"
 
@@ -1030,6 +1029,55 @@
 }
 
 void
+LrWpanMac::ReceiveInPromiscuousMode(uint8_t lqi,
+                                    const LrWpanMacHeader& receivedMacHdr,
+                                    Ptr<Packet> p)
+{
+    NS_LOG_FUNCTION(this);
+
+    NS_LOG_DEBUG("promiscuous mode, forwarding up");
+
+    // TODO: Fix here, this should trigger different Indication Callbacks
+    // depending the type of frame received (data,command, beacon)
+    if (!m_mcpsDataIndicationCallback.IsNull())
+    {
+        McpsDataIndicationParams params;
+        params.m_dsn = receivedMacHdr.GetSeqNum();
+        params.m_mpduLinkQuality = lqi;
+        params.m_srcPanId = receivedMacHdr.GetSrcPanId();
+        params.m_srcAddrMode = receivedMacHdr.GetSrcAddrMode();
+
+        switch (params.m_srcAddrMode)
+        {
+        case SHORT_ADDR:
+            params.m_srcAddr = receivedMacHdr.GetShortSrcAddr();
+            break;
+        case EXT_ADDR:
+            params.m_srcExtAddr = receivedMacHdr.GetExtSrcAddr();
+            break;
+        default:
+            break;
+        }
+
+        params.m_dstPanId = receivedMacHdr.GetDstPanId();
+        params.m_dstAddrMode = receivedMacHdr.GetDstAddrMode();
+
+        switch (params.m_dstAddrMode)
+        {
+        case SHORT_ADDR:
+            params.m_dstAddr = receivedMacHdr.GetShortDstAddr();
+            break;
+        case EXT_ADDR:
+            params.m_dstExtAddr = receivedMacHdr.GetExtDstAddr();
+            break;
+        default:
+            break;
+        }
+        m_mcpsDataIndicationCallback(params, p);
+    }
+}
+
+void
 LrWpanMac::SendOneBeacon()
 {
     NS_LOG_FUNCTION(this);
@@ -1754,7 +1802,7 @@
 }
 
 void
-LrWpanMac::ReceiveBeacon(uint8_t lqi, Ptr<Packet> p)
+LrWpanMac::ReceiveBeacon(uint8_t lqi, const LrWpanMacHeader& receivedMacHdr, Ptr<Packet> p)
 {
     NS_LOG_FUNCTION(this << lqi << p);
     // The received beacon size in symbols
@@ -1771,13 +1819,7 @@
     NS_LOG_DEBUG("Beacon Received; forwarding up (m_macBeaconRxTime: "
                  << m_macBeaconRxTime.As(Time::S) << ")");
 
-    // Strip the MAC header, the trailer and the Beacon Payload
-    LrWpanMacTrailer receivedMacTrailer;
-    p->RemoveTrailer(receivedMacTrailer);
-
-    LrWpanMacHeader receivedMacHdr;
-    p->RemoveHeader(receivedMacHdr);
-
+    // Strip the Beacon Payload
     BeaconPayloadHeader receivedMacPayload;
     p->RemoveHeader(receivedMacPayload);
 
@@ -1958,6 +2000,310 @@
 }
 
 void
+LrWpanMac::ReceiveCommand(uint8_t lqi, const LrWpanMacHeader& receivedMacHdr, Ptr<Packet> p)
+{
+    NS_LOG_FUNCTION(this << lqi << p);
+
+    auto symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
+
+    CommandPayloadHeader receivedMacPayload;
+    p->RemoveHeader(receivedMacPayload);
+
+    switch (receivedMacPayload.GetCommandFrameType())
+    {
+    case CommandPayloadHeader::BEACON_REQ:
+        if (m_csmaCa->IsUnSlottedCsmaCa() && m_coor)
+        {
+            // Jitter = Between 0 and 2 aUnitBackoffPeriods
+            // (0, 320us or 640us in 2.4Ghz O-QPSK)
+            // While this jitter is not described by the standard,
+            // it reduces the probability of collisions in beacons
+            // transmitted as a result of a beacon request
+            Time jitter =
+                Seconds(static_cast<double>(m_uniformVar->GetInteger(0, 3) * aUnitBackoffPeriod) /
+                        symbolRate);
+
+            Simulator::Schedule((jitter), &LrWpanMac::SendOneBeacon, this);
+        }
+        else
+        {
+            NS_LOG_DEBUG("Beacon Request command received in beacon mode: Ignore");
+        }
+        break;
+    case CommandPayloadHeader::ORPHAN_NOTIF:
+        if (m_coor)
+        {
+            if (!m_mlmeOrphanIndicationCallback.IsNull())
+            {
+                MlmeOrphanIndicationParams orphanParams;
+                orphanParams.m_orphanAddr = receivedMacHdr.GetExtSrcAddr();
+                m_mlmeOrphanIndicationCallback(orphanParams);
+            }
+        }
+        break;
+    case CommandPayloadHeader::COOR_REALIGN:
+        if (m_scanOrphanEvent.IsPending())
+        {
+            // Coordinator located, no need to keep scanning other channels
+            m_scanOrphanEvent.Cancel();
+
+            m_macPanIdScan = 0;
+            m_pendPrimitive = MLME_NONE;
+            m_channelScanIndex = 0;
+
+            // Update the device information with the received information
+            // from the Coordinator Realigment command.
+            m_macPanId = receivedMacPayload.GetPanId();
+            m_shortAddress = receivedMacPayload.GetShortAddr();
+            m_macCoordExtendedAddress = receivedMacHdr.GetExtSrcAddr();
+            m_macCoordShortAddress = receivedMacPayload.GetCoordShortAddr();
+
+            if (!m_mlmeScanConfirmCallback.IsNull())
+            {
+                MlmeScanConfirmParams confirmParams;
+                confirmParams.m_scanType = m_scanParams.m_scanType;
+                confirmParams.m_chPage = m_scanParams.m_chPage;
+                confirmParams.m_status = MacStatus::SUCCESS;
+                m_mlmeScanConfirmCallback(confirmParams);
+            }
+            m_scanParams = {};
+        }
+        // TODO: handle Coordinator realignment when not
+        //       used during an orphan scan.
+        break;
+    default:
+        break;
+    }
+}
+
+void
+LrWpanMac::ReceiveData(uint8_t lqi, const LrWpanMacHeader& receivedMacHdr, Ptr<Packet> p)
+{
+    NS_LOG_FUNCTION(this << lqi << p);
+
+    NS_LOG_DEBUG("Data Packet is for me; forwarding up");
+
+    if (!m_mcpsDataIndicationCallback.IsNull())
+    {
+        McpsDataIndicationParams params;
+        params.m_dsn = receivedMacHdr.GetSeqNum();
+        params.m_mpduLinkQuality = lqi;
+        params.m_srcPanId = receivedMacHdr.GetSrcPanId();
+        params.m_srcAddrMode = receivedMacHdr.GetSrcAddrMode();
+
+        switch (params.m_srcAddrMode)
+        {
+        case SHORT_ADDR:
+            params.m_srcAddr = receivedMacHdr.GetShortSrcAddr();
+            break;
+        case EXT_ADDR:
+            params.m_srcExtAddr = receivedMacHdr.GetExtSrcAddr();
+            break;
+        default:
+            break;
+        }
+
+        params.m_dstPanId = receivedMacHdr.GetDstPanId();
+        params.m_dstAddrMode = receivedMacHdr.GetDstAddrMode();
+
+        switch (params.m_dstAddrMode)
+        {
+        case SHORT_ADDR:
+            params.m_dstAddr = receivedMacHdr.GetShortDstAddr();
+            break;
+        case EXT_ADDR:
+            params.m_dstExtAddr = receivedMacHdr.GetExtDstAddr();
+            break;
+        default:
+            break;
+        }
+
+        m_mcpsDataIndicationCallback(params, p);
+    }
+}
+
+void
+LrWpanMac::ReceiveAcknowledgment(const LrWpanMacHeader& receivedMacHdr, Ptr<Packet> p)
+{
+    NS_LOG_FUNCTION(this << p);
+
+    // Make a copy of the original transmitted packet that required ACK and
+    // extract its MAC header.
+    Ptr<Packet> txPkt = m_txPkt->Copy();
+    LrWpanMacHeader txMacHdr;
+    txPkt->RemoveHeader(txMacHdr);
+
+    // If it is an ACK with an unexpected sequence number, mark the current
+    // transmission as failed and start a retransmit. (cf 7.5.6.4.3)
+    if (receivedMacHdr.GetSeqNum() != txMacHdr.GetSeqNum())
+    {
+        m_ackWaitTimeout.Cancel();
+        if (!PrepareRetransmission())
+        {
+            m_setMacState.Cancel();
+            m_setMacState = Simulator::ScheduleNow(&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+        }
+        else
+        {
+            m_setMacState.Cancel();
+            m_setMacState = Simulator::ScheduleNow(&LrWpanMac::SetLrWpanMacState, this, MAC_CSMA);
+        }
+
+        return;
+    }
+
+    // If it is an ACK with the expected sequence number, finish the transmission
+    m_ackWaitTimeout.Cancel();
+    m_macTxOkTrace(m_txPkt);
+
+    // TODO: check  if the IFS is the correct size after ACK.
+    double symbolRate = m_phy->GetDataOrSymbolRate(false);
+    Time ifsWaitTime = Seconds((double)GetIfsSize() / symbolRate);
+
+    if (txMacHdr.IsCommand())
+    {
+        // We received an ACK to a command, we need to take actions depending on the
+        // transmitted command.
+
+        // Extract the command payload of the originally transmitted packet to know
+        // what command we transmitted.
+        CommandPayloadHeader txCmdPayload;
+        txPkt->RemoveHeader(txCmdPayload);
+
+        switch (txCmdPayload.GetCommandFrameType())
+        {
+        case CommandPayloadHeader::ASSOCIATION_REQ: {
+            Time waitTime = Seconds(static_cast<double>(m_macResponseWaitTime) / symbolRate);
+            if (!m_beaconTrackingOn)
+            {
+                m_respWaitTimeout =
+                    Simulator::Schedule(waitTime, &LrWpanMac::SendDataRequestCommand, this);
+            }
+            else
+            {
+                // TODO: The data must be extracted by the coordinator within
+                // macResponseWaitTime on timeout, MLME-ASSOCIATE.confirm is set
+                // with status NO_DATA, and this should trigger the cancellation
+                // of the beacon tracking (MLME-SYNC.request  trackBeacon
+                // =FALSE)
+            }
+            break;
+        }
+
+        case CommandPayloadHeader::ASSOCIATION_RESP: {
+            // MLME-comm-status.Indication generated as a result of an
+            // association response command, therefore src and dst address use
+            // extended mode (see 5.3.2.1)
+            if (!m_mlmeCommStatusIndicationCallback.IsNull())
+            {
+                MlmeCommStatusIndicationParams commStatusParams;
+                commStatusParams.m_panId = m_macPanId;
+                commStatusParams.m_srcAddrMode = LrWpanMacHeader::EXTADDR;
+                commStatusParams.m_srcExtAddr = txMacHdr.GetExtSrcAddr();
+                commStatusParams.m_dstAddrMode = LrWpanMacHeader::EXTADDR;
+                commStatusParams.m_dstExtAddr = txMacHdr.GetExtDstAddr();
+                commStatusParams.m_status = MacStatus::SUCCESS;
+                m_mlmeCommStatusIndicationCallback(commStatusParams);
+            }
+            // Remove element from Pending Transaction List
+            RemovePendTxQElement(m_txPkt->Copy());
+            break;
+        }
+
+        case CommandPayloadHeader::DATA_REQ: {
+            if (!m_ignoreDataCmdAck)
+            {
+                // Schedule an event in case the Association Response Command
+                // never reached this device during an association process.
+                Time waitTime = Seconds(static_cast<double>(m_assocRespCmdWaitTime) / symbolRate);
+                m_assocResCmdWaitTimeout =
+                    Simulator::Schedule(waitTime, &LrWpanMac::LostAssocRespCommand, this);
+            }
+
+            if (!m_mlmePollConfirmCallback.IsNull())
+            {
+                MlmePollConfirmParams pollConfirmParams;
+                pollConfirmParams.m_status = MacStatus::SUCCESS;
+                m_mlmePollConfirmCallback(pollConfirmParams);
+            }
+            break;
+        }
+
+        case CommandPayloadHeader::COOR_REALIGN: {
+            // ACK of coordinator realigment commands is not specified in the
+            // standard, in here, we assume they are required as in other
+            // commands.
+            if (!m_mlmeCommStatusIndicationCallback.IsNull())
+            {
+                MlmeCommStatusIndicationParams commStatusParams;
+                commStatusParams.m_panId = m_macPanId;
+                commStatusParams.m_srcAddrMode = LrWpanMacHeader::EXTADDR;
+                commStatusParams.m_srcExtAddr = txMacHdr.GetExtSrcAddr();
+                commStatusParams.m_dstAddrMode = LrWpanMacHeader::EXTADDR;
+                commStatusParams.m_dstExtAddr = txMacHdr.GetExtDstAddr();
+                commStatusParams.m_status = MacStatus::SUCCESS;
+                m_mlmeCommStatusIndicationCallback(commStatusParams);
+            }
+            break;
+        }
+
+        default: {
+            // TODO: add response to other request commands (e.g. Orphan)
+            break;
+        }
+        }
+    }
+    else
+    {
+        // Receive ACK to data packet
+        if (!m_mcpsDataConfirmCallback.IsNull())
+        {
+            Ptr<TxQueueElement> txQElement = m_txQueue.front();
+            McpsDataConfirmParams confirmParams;
+            confirmParams.m_msduHandle = txQElement->txQMsduHandle;
+            confirmParams.m_status = MacStatus::SUCCESS;
+            m_mcpsDataConfirmCallback(confirmParams);
+        }
+    }
+
+    // Ack was successfully received, wait for the Interframe Space (IFS) and
+    // then proceed
+    RemoveFirstTxQElement();
+    m_setMacState.Cancel();
+    m_setMacState = Simulator::ScheduleNow(&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+    m_ifsEvent = Simulator::Schedule(ifsWaitTime, &LrWpanMac::IfsWaitTimeout, this, ifsWaitTime);
+}
+
+void
+LrWpanMac::PrintReceivedPacket(const LrWpanMacHeader& receivedMacHdr)
+{
+    if (receivedMacHdr.GetSrcAddrMode() == SHORT_ADDR &&
+        receivedMacHdr.GetDstAddrMode() == SHORT_ADDR)
+    {
+        NS_LOG_DEBUG("Packet from [" << receivedMacHdr.GetShortSrcAddr() << "] to ["
+                                     << receivedMacHdr.GetShortDstAddr() << "]");
+    }
+    else if (receivedMacHdr.GetSrcAddrMode() == EXT_ADDR &&
+             receivedMacHdr.GetDstAddrMode() == EXT_ADDR)
+    {
+        NS_LOG_DEBUG("Packet from [" << receivedMacHdr.GetExtSrcAddr() << "] to ["
+                                     << receivedMacHdr.GetExtDstAddr() << "]");
+    }
+    else if (receivedMacHdr.GetSrcAddrMode() == SHORT_ADDR &&
+             receivedMacHdr.GetDstAddrMode() == EXT_ADDR)
+    {
+        NS_LOG_DEBUG("Packet from [" << receivedMacHdr.GetShortSrcAddr() << "] to ["
+                                     << receivedMacHdr.GetExtDstAddr() << "]");
+    }
+    else if (receivedMacHdr.GetSrcAddrMode() == EXT_ADDR &&
+             receivedMacHdr.GetDstAddrMode() == SHORT_ADDR)
+    {
+        NS_LOG_DEBUG("Packet from [" << receivedMacHdr.GetExtSrcAddr() << "] to ["
+                                     << receivedMacHdr.GetShortDstAddr() << "]");
+    }
+}
+
+void
 LrWpanMac::CheckQueue()
 {
     NS_LOG_FUNCTION(this);
